--------------------------------------------------------------------------------
-- Copyright (c) 1995-2007 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.2.04i
--  \   \         Application : sch2vhdl
--  /   /         Filename : premiertp.vhf
-- /___/   /\     Timestamp : 05/24/2012 14:07:21
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: C:\PROGRAMS\Xilinx92i\bin\nt\sch2vhdl.exe -intstyle ise -family spartan3e -flat -suppress -w U:/Miniprojetnum/tele/premiertp.sch premiertp.vhf
--Design Name: premiertp
--Device: spartan3e
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesis and simulted, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity premiertp is
   port ( clk            : in    std_logic; 
          colorchoice_in : in    std_logic_vector (7 downto 0); 
          column_in      : in    std_logic_vector (7 downto 0); 
          dinb_in        : in    std_logic_vector (0 downto 0); 
          reset          : in    std_logic; 
          row_in         : in    std_logic_vector (6 downto 0); 
          web_in         : in    std_logic; 
          hSync          : out   std_logic; 
          rgb            : out   std_logic_vector (7 downto 0); 
          vSync          : out   std_logic);
end premiertp;

architecture BEHAVIORAL of premiertp is
   attribute BOX_TYPE   : string ;
   signal XLXN_1         : std_logic;
   signal XLXN_9         : std_logic_vector (0 downto 0);
   signal XLXN_12        : std_logic_vector (14 downto 0);
   signal XLXN_14        : std_logic_vector (7 downto 0);
   signal XLXN_15        : std_logic_vector (6 downto 0);
   signal XLXN_21        : std_logic_vector (14 downto 0);
   signal XLXN_22        : std_logic_vector (0 downto 0);
   component conversioncouleur
      port ( videoOn     : in    std_logic; 
             colorOut    : in    std_logic_vector (0 downto 0); 
             colorchoice : in    std_logic_vector (7 downto 0); 
             pointeur    : in    std_logic_vector (14 downto 0); 
             defilement  : in    std_logic_vector (14 downto 0); 
             rgb         : out   std_logic_vector (7 downto 0); 
             clk         : in    std_logic);
   end component;
   
   component vgaControler
      port ( clk     : in    std_logic; 
             hSync   : out   std_logic; 
             vSync   : out   std_logic; 
             videoOn : out   std_logic; 
             column  : out   std_logic_vector (7 downto 0); 
             row     : out   std_logic_vector (6 downto 0));
   end component;
   
   component RamBlockDblPort
      port ( addra : in    std_logic_vector (14 downto 0); 
             dina  : in    std_logic_vector (0 downto 0); 
             wea   : in    std_logic; 
             clka  : in    std_logic; 
             addrb : in    std_logic_vector (14 downto 0); 
             dinb  : in    std_logic_vector (0 downto 0); 
             web   : in    std_logic; 
             clkb  : in    std_logic; 
             douta : out   std_logic_vector (0 downto 0));
   end component;
   
   component merge
      port ( column : in    std_logic_vector (7 downto 0); 
             row    : in    std_logic_vector (6 downto 0); 
             adress : out   std_logic_vector (14 downto 0));
   end component;
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : component is "BLACK_BOX";
   
begin
   XLXI_1 : conversioncouleur
      port map (clk=>clk,
                colorchoice(7 downto 0)=>colorchoice_in(7 downto 0),
                colorOut(0)=>XLXN_9(0),
                defilement(14 downto 0)=>XLXN_21(14 downto 0),
                pointeur(14 downto 0)=>XLXN_12(14 downto 0),
                videoOn=>XLXN_1,
                rgb(7 downto 0)=>rgb(7 downto 0));
   
   XLXI_2 : vgaControler
      port map (clk=>clk,
                column(7 downto 0)=>XLXN_14(7 downto 0),
                hSync=>hSync,
                row(6 downto 0)=>XLXN_15(6 downto 0),
                videoOn=>XLXN_1,
                vSync=>vSync);
   
   XLXI_5 : RamBlockDblPort
      port map (addra(14 downto 0)=>XLXN_12(14 downto 0),
                addrb(14 downto 0)=>XLXN_21(14 downto 0),
                clka=>clk,
                clkb=>clk,
                dina(0)=>XLXN_22(0),
                dinb(0)=>dinb_in(0),
                wea=>reset,
                web=>web_in,
                douta(0)=>XLXN_9(0));
   
   XLXI_15 : merge
      port map (column(7 downto 0)=>XLXN_14(7 downto 0),
                row(6 downto 0)=>XLXN_15(6 downto 0),
                adress(14 downto 0)=>XLXN_12(14 downto 0));
   
   XLXI_16 : merge
      port map (column(7 downto 0)=>column_in(7 downto 0),
                row(6 downto 0)=>row_in(6 downto 0),
                adress(14 downto 0)=>XLXN_21(14 downto 0));
   
   XLXI_17 : GND
      port map (G=>XLXN_22(0));
   
end BEHAVIORAL;


